<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    version="1.0"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:pa="http://www.w3.org/2002/ws/databinding/patterns/6/09/"
    xmlns:ex="http://www.w3.org/2002/ws/databinding/examples/6/09/" 
    exclude-result-prefixes="xs pa ex">
    
    <xsl:output method="xml" indent="yes" encoding="UTF-8" />
    
    <!-- match the issues that require examples with the list of examples -->
    
    <xsl:variable name="list-examples" select="document('list-examples.xml')"/>
    <xsl:variable name="list-pattern-issues" select="document('list-pattern-issues.xml')"/>
    
    <xsl:template match="issues-requiring-examples">
        <issues>
            <!-- for each issue requiring an example check list-patterns-issues.xml  -->
            <xsl:for-each select="issue-required">
                <required-issue>
                    <xsl:variable name="origin" select="@id"/>
                    <xsl:attribute name="id">
                        <xsl:value-of select="$origin"/>
                    </xsl:attribute>
                    <!-- For each pattern/issue found in the examples.xml -->
                    <xsl:for-each select="$list-pattern-issues/issues-listed-from-patterns/pattern">
                        <!-- check that the required issue origin matches the pattern issue id -->
                        <xsl:if test="$origin = @origin">
                            <pattern>
                                <xsl:variable name="pattern" select="@pattern"/>
                                <xsl:attribute name="id">
                                    <xsl:value-of select="$pattern"/>
                                </xsl:attribute>    
                                <!-- for each pattern check that an example exists  -->
                                <xsl:for-each select="$list-examples/examples/example">
                                    <xsl:if test="$pattern = @ex-id">
                                        <example>
                                            <xsl:attribute name="id">
                                                <xsl:value-of select="@ex-id"/>
                                            </xsl:attribute>    
                                        </example>
                                    </xsl:if>    
                                </xsl:for-each>
                            </pattern>
                        </xsl:if>
                    </xsl:for-each>
                </required-issue>
            </xsl:for-each>                      
        </issues>    
    </xsl:template>    
    
</xsl:stylesheet>
